/*
 * @(#) GooglePlugin.java 1.0 2002/01/11
 * Written by jaseb
 * 
 * Requires ircApi.jar
 *			gnu regexp packages
 */
 
package ircbot.plugins;

import ircbot.IrcBot;
import ircbot.BotPlugin;
import ircbot.BotEngine;
import java.util.*;
import java.io.*;
import java.net.*;
import gnu.regexp.*;

public class GooglePlugin implements BotPlugin
{
	private IrcBot ircBot;
	//private ArrayList records = new ArrayList();
	private boolean running = true;
	
	/**
		Exposes the available commands to the ircBot
	*/ 
	public String getCommands()
	{
		return "fetch a google search: google [search string]";
	}
	
	/** Registers the ircBot
	*/
	
	public void register(IrcBot ircBot)
	{
		this.ircBot = ircBot;
	}
	
	/** Parses the incoming message then scans the "naughty words" array.  If there are no naughty words
	    then it uses sendSocket to connect to Google and do a search.  Finally the results are parsed 
	    and returned to the client.
	*/
	
	public void message(int dccindex, String channel, String from, String message, String ident, String servername)
	{	
	
		// A basic string array of naughty words that we do not want people to search on.
		// Case should not matter as the regex engine ignores case.		
		String[] banWords = {"porn","sex"};
		boolean banFlag = false;	
		//Only look for messages in the channel
		StringTokenizer st = new StringTokenizer(message);
		StringBuffer googleString = new StringBuffer();
		String sentString = "";	
		String returnString = "";								
		if (st.hasMoreTokens())
		{			
			String action = st.nextToken();				
			if (running)
			{
				// make sure that we are dealing with a google request
				if (action.equals("google") || action.equals("Google") || action.equals("GOOGLE"))
				{
					while(st.hasMoreTokens())
					{
						// This will be our search string.
						// "search?q=whatever+whatever+whatever
						googleString.append(st.nextToken()+"+");
					}
					if(googleString.length() > 0)
						googleString.deleteCharAt(googleString.length()-1);
						
					for (int i=1; i <= banWords.length ; i++) {
						try {
							RE regexp = new RE(banWords[i-1],RE.REG_ICASE);
							REMatchEnumeration match = regexp.getMatchEnumeration(googleString.toString());
							if(match.hasMoreMatches()){
								banFlag=true;
								System.out.println("Set banFlag to true");
							}
						} catch (Exception e) {
							// Do nothing
						}								
					}
					if(banFlag == false) {
						ircBot.send(dccindex, channel, from, "searching for: " + googleString.toString());							
						try {
							returnString = sendSocket(googleString.toString(),"www.google.com",80);
						} catch (Exception e) {
							System.out.println(e);	
						}
						
						String outputtoIRC = stripURLs(returnString);
						ircBot.print(dccindex ,outputtoIRC, from, 0);			
					} else {
						ircBot.send(dccindex, channel, from, "You cannot search for naughty words!");	
					}	
				}			
			}
		}
	}
			
	/**
	Parses the html and uses a regular expression to rip out the http://.......
	Google uses http://images.google.com, http://www.google.com and http://groups.google.com
	within it's page.  Also there references to http://www.dictionary.com that we don't require.
	*/
	public String stripURLs(String htmlpage) {
		int counter=0;
		StringBuffer retUrls = new StringBuffer();
		try {
			RE regexp = new RE("(http://[^>]+)",RE.REG_ICASE);
			REMatchEnumeration match = regexp.getMatchEnumeration(htmlpage);
			while (match.hasMoreElements()){
			// toString with a (1) gives sub expressions,
			// like $1, $2 etc -ie, the stuff inside
			// brackets in normal regexps
				String externalURL=(match.nextMatch()).toString();
				// A bit hard coded for the beta version, needs tidying up.
				if(externalURL.startsWith("http://www.google.com") || externalURL.startsWith("http://groups.google.com")||externalURL.startsWith("http://images.google.com")||externalURL.startsWith("http://www.dictionary.com")) {	
					// Do nothing
				} else {
					if(counter <= 4) {
						counter++;
						retUrls.append(externalURL + "\n");
					}
				}
			}
		} catch (Exception e){
			//Do nowt!
		}
		return retUrls.toString();	
	}
	
	/**
	Opens a socket connection to Google and sends a HTTP GET with the search string.
	Returns the returned html back.
	*/
	public String sendSocket(String s, String s1, int i) 
	{
		StringBuffer outbound = new StringBuffer();
		outbound.append("GET /search?q=" + s + " HTTP/1.0\n");
		outbound.append("User-Agent: GooglePlugin1.0(IrcBot)\n");
		outbound.append("Host: www.google.com\n");
		outbound.append("Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*\n\n");
		
		
		StringBuffer stringbuffer = new StringBuffer();
		try {
			Socket socket = new Socket(s1, i);
			BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			DataOutputStream dataoutputstream = new DataOutputStream(socket.getOutputStream());
			dataoutputstream.writeBytes(outbound.toString());
			int j;
			while((j = bufferedreader.read()) >= 0) {
				char c = (char)j;
				stringbuffer.append(c);
			}
			bufferedreader.close();
			dataoutputstream.close();
		} catch(SocketException e) {
			System.out.println(e);
		} catch(UnknownHostException e) {
			System.out.println(e);
		} catch(IOException e) {
			System.out.println(e);
		}
		return stringbuffer.toString();
	}
}